; MPU-401 Driver lhcd  (c) A.T / ASCII Sound group 1993 nov.

%include 'hoot.inc'

	ORG 0x0100
	USE16
	CPU 186

main:
	cli
	
	mov dx, HOOTFUNC
	mov al, HF_DISABLE
	out dx, al
	
	push cs
	pop ds
	mov dx, hootfunc
	mov ax, 0x257f
	int 0x21
	
	mov dx, HOOTFUNC
	mov al, HF_ENABLE
	out dx, al
	
	sti

mainloop:
	hlt
	jmp mainloop

hootfunc:
	cli
	
	pusha
	push ds
	push es
	
	mov dx, HOOTPORT
	mov al, HF_DISABLE
	out dx, al
	
	mov dx, HOOTPORT
	in al, dx
	
	cmp al, HP_PLAY
	je hootfunc_play
	
	cmp al, HP_STOP
	je hootfunc_stop

hootfunc_end:
	mov dx, HOOTFUNC
	mov al, HF_ENABLE
	out dx, al
	
	pop es
	pop ds
	popa
	
	sti
	
	iret

hootfunc_play:
	xor ax, ax	; t~
	int 0x58
	
	mov dx, buff
	xor bx, bx
	mov cx, 0xffff
	mov ah, 0x3f
	int 0x21
	
	mov si, dx
	mov ax, 0x0100	; tJn
	int 0x58
	
	jmp hootfunc_end

hootfunc_stop:
	xor ax, ax	; t~
	int 0x58
	
	jmp hootfunc_end

buff:

end:
	ends
